import React, { PropTypes } from 'react';
import PureRenderMixin from 'react-addons-pure-render-mixin';
import invariant from 'invariant';

import datepickerState from './redux/datepickerState';


export default ({
    Component
} = {}) => {

    invariant(Component !== undefined, 'Missing Datepicker component.');

    return React.createClass({

        displayName: `${Component.displayName}`,

        mixins: [PureRenderMixin],

        propTypes: {
            onChange: PropTypes.func,
            value: PropTypes.any
        },

        getDefaultProps() {
            return {
                onChange: (/* value */) => {},
                value: null
            };
        },

        getInitialState() {
            const { value } = this.props;
            const { currentMonth, expanded, selectedIndex } = datepickerState({ value });

            return {
                currentMonth,
                expanded,
                selectedIndex
            };
        },

        onChange(currentMonth, selectedIndex, value) {
            this.setState({ currentMonth, expanded: false, selectedIndex });
            this.props.onChange(value);
        },

        onCollapse(currentMonth, selectedIndex) {
            this.setState({ currentMonth, expanded: false, selectedIndex });
        },

        onExpand() {
            this.setState({ expanded: true });
        },

        onSelectedIndexChange(currentMonth, selectedIndex) {
            this.setState({ currentMonth, selectedIndex });
        },

        render() {
            return (
                <Component
                    { ...this.props }
                    { ...this.state }
                    onChange={ this.onChange }
                    onCollapse={ this.onCollapse }
                    onExpand={ this.onExpand }
                    onSelectedIndexChange={ this.onSelectedIndexChange } />
            );
        }

    });

};
