import datepickerState from './datepickerState';


describe('datepickerState', () => {

    it('null and collapsed as default', () => {
        const result = datepickerState();

        expect(result.expanded).toBe(false);
        expect(result.value).toBe(null);
    });

    it('value as selected index', () => {
        const value = +new Date(2000, 0, 31);
        const result = datepickerState({ value });

        expect(result.selectedIndex).toBe(value);
        expect(result.value).toBe(value);
    });

    it('start of month as current month of value', () => {
        const value = +new Date(2000, 0, 31);
        const result = datepickerState({ value });

        expect(result.currentMonth).toBe(+new Date(2000, 0, 1));
    });

    it('empty string is null', () => {
        const result = datepickerState({ value: '' });

        expect(result.value).toBe(null);
    });

});
