import getHighlightedIndex from './getHighlightedIndex';


describe('getHighlightedIndex', () => {

    it('no options', () => {
        const options = [];
        const value = '';

        const result = getHighlightedIndex({ options, value });
        expect(result).toBe(-1);
    });

    it('options with empty values', () => {
        const options = [{}, {}];
        const value = void(0);

        const result = getHighlightedIndex({ options, value });
        expect(result).toBe(-1);
    });

    it('options with no match', () => {
        const options = [{ value: '1' }, { value: '2' }];
        const value = '3';

        const result = getHighlightedIndex({ options, value });
        expect(result).toBe(-1);
    });

    it('options with match', () => {
        const options = [{ value: '1' }, { value: '2' }];
        const value = '2';

        const result = getHighlightedIndex({ options, value });
        expect(result).toBe(1);
    });

});
