import React, { PropTypes } from 'react';
import PureRenderMixin from 'react-addons-pure-render-mixin';
import { connect } from 'react-redux';
import invariant from 'invariant';

import actionName from '../../utils/actionName';
import getComponentState from '../../utils/getComponentState';

import monthpickerChange from './redux/monthpickerChange';


const changeType = actionName('CHANGE');

export {
    changeType
};

export default ({
    Component
} = {}) => {

    invariant(Component !== undefined, 'Missing Monthpicker component');

    const Container = React.createClass({

        displayName: `${Component.displayName}Container`,

        mixins: [PureRenderMixin],

        propTypes: {
            actionTypePrefix: PropTypes.string,
            customActionMetadata: PropTypes.object,
            path: PropTypes.string,
            root: PropTypes.string
        },

        render() {
            return (
                <Component { ...this.props } />
            );
        }

    });

    const mapStateToProps = (state, props) => {
        const { value } = getComponentState(state, props);
        return {
            value
        };
    };

    const mapDispatchToProps = (dispatch, props) => {
        const { customActionMetadata: custom, path, root } = props;
        const actionTypePrefix = props.actionTypePrefix || 'MONTHPICKER';

        return {
            onChange: (value) => dispatch(monthpickerChange({ custom, path, root, type: changeType(actionTypePrefix), value }))
        };
    };

    return connect(mapStateToProps, mapDispatchToProps)(Container);
};
