import toNumber from './toNumber';


describe('toNumber', () => {

    it('float: non-number as string', () => {
        const result = toNumber('x', 'float');
        expect(result).toEqual({ value: '', valid: false });
    });

    it('float: number as string', () => {
        const result = toNumber('1', 'float');
        expect(result).toEqual({ value: 1, valid: true });
    });

    it('float: comma', () => {
        const result = toNumber('11,11', 'float');
        expect(result).toEqual({ value: 11.11, valid: true });
    });

    it('float: dot', () => {
        const result = toNumber('11.11', 'float');
        expect(result).toEqual({ value: 11.11, valid: true });
    });

    it('float: minus', () => {
        const result = toNumber('-', 'float');
        expect(result).toEqual({ value: 0, valid: true });
    });

    it('float: multiple minuses', () => {
        const result = toNumber('--', 'float');
        expect(result).toEqual({ value: '', valid: false });
    });

    it('integer: non-number as string', () => {
        const result = toNumber('x', 'integer');
        expect(result).toEqual({ value: '', valid: false });
    });

    it('integer: number as string', () => {
        const result = toNumber('1', 'integer');
        expect(result).toEqual({ value: 1, valid: true });
    });

    it('integer: comma', () => {
        const result = toNumber('11,11', 'integer');
        expect(result).toEqual({ value: '', valid: false });
    });

    it('integer: dot', () => {
        const result = toNumber('11.11', 'integer');
        expect(result).toEqual({ value: '', valid: false });
    });

    it('float: minus', () => {
        const result = toNumber('-', 'integer');
        expect(result).toEqual({ value: 0, valid: true });
    });

    it('float: multiple minuses', () => {
        const result = toNumber('--', 'integer');
        expect(result).toEqual({ value: '', valid: false });
    });

});
