import getSeamlessPath from './getSeamlessPath';


describe('getSeamlessPath', () => {
    it('single root/path', () => {
        const result = getSeamlessPath('root', 'path');
        expect(result).toEqual(['root', 'path']);
    });

    it('no root/path', () => {
        const result = getSeamlessPath();
        // perhaps there should be an error in stead of an empty array.
        expect(result).toEqual([]);
    });

    it('no path', () => {
        const result = getSeamlessPath('root');
        expect(result).toEqual(['root']);
    });

    it('dotted path', () => {
        const result = getSeamlessPath('root', 'path.to');
        expect(result).toEqual(['root', 'path', 'to']);
    });

    it('dotted root', () => {
        const result = getSeamlessPath('root.to', 'path');
        expect(result).toEqual(['root', 'to', 'path']);
    });

    it('indexed path', () => {
        const result = getSeamlessPath('root', 'path[0]');
        expect(result).toEqual(['root', 'path', '0']);
    });

    it('legacy indexed path', () => {
        const result = getSeamlessPath('root', 'path.[0]');
        expect(result).toEqual(['root', 'path', '0']);
    });

    it('indexed root', () => {
        const result = getSeamlessPath('root[0]', 'path');
        expect(result).toEqual(['root', '0', 'path']);
    });

    it('legacy indexed root', () => {
        const result = getSeamlessPath('root.[0]', 'path');
        expect(result).toEqual(['root', '0', 'path']);
    });
});
