import isObject from './isObject';


describe('isObject', () => {

    [
        { name: 'object', data: {} }
    ].forEach((fixture) => {
        it(fixture.name, () => {
            const result = isObject(fixture.data);
            expect(result).toBe(true);
        });
    });

    [
        { name: 'false', data: false },
        { name: 'true', data: true },
        { name: 'number (falsy)', data: 0 },
        { name: 'number (non-falsy)', data: 1 },
        { name: 'string (falsy)', data: '' },
        { name: 'string (non-falsy)', data: 'x' },
        { name: 'array', data: [] },
        { name: 'null', data: null },
        { name: 'undefined', data: undefined },
        { name: 'function', data: function() {} },
        { name: 'symbol', data: Symbol() }
    ].forEach((fixture) => {
        it(fixture.name, () => {
            const result = isObject(fixture.data);
            expect(result).toBe(false);
        });
    });

});
